/*--------------------------------------------------
 *	cell.c
 *	륪ȥޥȥʥȡ饹
 *--------------------------------------------------*/

#include "cell.h"

void make_cell(cell **c, int x, int y){
	cell *cp;
	int i, j;

	cp = *c = (cell *)malloc(sizeof(cell));

	cp->toggle = 0;
	cp->size_x = x;
	cp->size_y = y;

	cp->data = (int ***)malloc(sizeof(int **)*2);
	for(i=0; i<2; i++){
		cp->data[i] = (int **)malloc(sizeof(int *)*x);
		for(j=0; j<x; j++){
			cp->data[i][j] = (int *)malloc(sizeof(int)*y);
		}
	}

	cp->rule = (int *)malloc(sizeof(int)*16);
}

void delete_cell(cell *c){
	int i, j;

	free(c->rule);

	for(i=0; i<2; i++){
		for(j=0; j<(c->size_x); j++){
			free(c->data[i][j]);
		}
		free(c->data[i]);
	}
	free(c->data);

	free(c);
}

void cell_init(cell *c){
	int i, j;
	time_t t;

	/* ǽ */
	srand(time(&t));
	for(i=0; i<(c->size_x); i++){
		for(j=0; j<(c->size_y); j++){
			c->data[0][i][j] = rand() % 2;
		}
	}
	for(i=0; i<16; i++){
		c->rule[i] = rand() % 2;
	}
}

void cell_set_rule(cell *c, int id, int rule){
	c->rule[id] = rule % 2;	//Τ
}

int cell_get_rule(cell *c, int id){
	return c->rule[id];
}

void cell_calc_next(cell *c){
	int now, next;
	int tx, ty, rx, ry, bx, by, lx, ly;
	int id;
	int i, j;

	now = c->toggle;
	next = (now+1) % 2;

	for(i=0; i<(c->size_x); i++){
		for(j=0; j<(c->size_y); j++){
			tx = (i + c->size_x - 1) % c->size_x;	// ȡ饹ι
			bx = (i + 1) % c->size_x;
			ty = by = j;
			ly = (j + c->size_y - 1) % c->size_y;	// ȡ饹ι
			ry = (j + 1) % c->size_y;
			rx = lx = i;

			id = 1*(c->data[now][tx][ty])
				+ 2*(c->data[now][rx][ry])
				+ 4*(c->data[now][bx][by])
				+ 8*(c->data[now][lx][ly]);

			c->data[next][i][j] = c->rule[id];
		}
	}

	c->toggle = next;
}

void cell_set_data(cell *c, int x, int y, int value){
	c->data[c->toggle][x][y] = value % 2;
}

int cell_get_data(cell *c, int x, int y){
	return c->data[c->toggle][x][y];
}

