/*--------------------------------------------------
 *	neuron.c
 *	cellѤ
 *--------------------------------------------------*/

#include "neuron.h"

void make_neuron(neuron **nu, int dim, int length){
	neuron *np;

	np = *nu = (neuron *)malloc(sizeof(neuron));

	make_cell(&(np->c), dim, 2*length+2);
	np->dim = dim;
	np->length = length;
}

void delete_neuron(neuron *nu){
	delete_cell(nu->c);
	free(nu);
}

void neuron_init(neuron *nu){
	cell_init(nu->c);
}

void neuron_set_rule(neuron *nu, int id, int rule){
	cell_set_rule(nu->c, id, rule);
}

int neuron_get_rule(neuron *nu, int id){
	return cell_get_rule(nu->c, id);
}

void neuron_calc_next(neuron *nu){
	cell_calc_next(nu->c);
}

void neuron_input(neuron *nu, int *in){
	int i;

	for(i=0; i<(nu->dim); i++){
		cell_set_data(nu->c, i, 0, in[i]);
	}
}

void neuron_output(neuron *nu, int *out){
	int i;

	for(i=0; i<(nu->dim); i++){
		out[i] = cell_get_data(nu->c, i, nu->length + 1);
	}
}

