#include <curses.h>
#include "neuron.h"
#include "body.h"

#define WAIT 5

int main(void){
	neuron *nu;
	body *b;
	int out[8];
	int i;
	int in;

	initscr();
	noecho();
	halfdelay(WAIT);

	make_neuron(&nu, 8, 5);
	neuron_init(nu);

	make_body(&b);
	body_set_vposi(b, (COLS-FACE_W)/2);	//

	do{
		clear();

		neuron_output(nu, out);
		body_set_face(b, 1*out[0]+2*out[1]+4*out[2]);
		body_move(b, 1*out[3]+2*out[4]+4*out[5], 1*out[6]+2*out[7]);

		if(body_get_vposi(b) > (COLS-FACE_W)){
			body_set_vposi(b, COLS-FACE_W);
		}

		mvprintw(10-body_get_hposi(b), body_get_vposi(b), "%s", body_get_face(b));
		for(i=0; i<COLS-1; i+=2){
			mvprintw(11, i, "");
		}
		mvprintw(0, 0, "To exit, press 'q'. To change neuron rule randomly, press other key.");

		refresh();
		neuron_calc_next(nu);

		in = getch();
		if(in == 'q'){
			break;
		}
		else{
			neuron_init(nu);
		}
	}while(1);

	endwin();
	return 0;
}

